<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX User Guide: vx_internal.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
    </ul>
  </div>
<h1>vx_internal.h</h1><a href="vx__internal_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment"> * Copyright (c) 2012-2016 The Khronos Group Inc.</span>
<a name="l00003"></a>00003 <span class="comment"> *</span>
<a name="l00004"></a>00004 <span class="comment"> * Permission is hereby granted, free of charge, to any person obtaining a</span>
<a name="l00005"></a>00005 <span class="comment"> * copy of this software and/or associated documentation files (the</span>
<a name="l00006"></a>00006 <span class="comment"> * &quot;Materials&quot;), to deal in the Materials without restriction, including</span>
<a name="l00007"></a>00007 <span class="comment"> * without limitation the rights to use, copy, modify, merge, publish,</span>
<a name="l00008"></a>00008 <span class="comment"> * distribute, sublicense, and/or sell copies of the Materials, and to</span>
<a name="l00009"></a>00009 <span class="comment"> * permit persons to whom the Materials are furnished to do so, subject to</span>
<a name="l00010"></a>00010 <span class="comment"> * the following conditions:</span>
<a name="l00011"></a>00011 <span class="comment"> *</span>
<a name="l00012"></a>00012 <span class="comment"> * The above copyright notice and this permission notice shall be included</span>
<a name="l00013"></a>00013 <span class="comment"> * in all copies or substantial portions of the Materials.</span>
<a name="l00014"></a>00014 <span class="comment"> *</span>
<a name="l00015"></a>00015 <span class="comment"> * MODIFICATIONS TO THIS FILE MAY MEAN IT NO LONGER ACCURATELY REFLECTS</span>
<a name="l00016"></a>00016 <span class="comment"> * KHRONOS STANDARDS. THE UNMODIFIED, NORMATIVE VERSIONS OF KHRONOS</span>
<a name="l00017"></a>00017 <span class="comment"> * SPECIFICATIONS AND HEADER INFORMATION ARE LOCATED AT</span>
<a name="l00018"></a>00018 <span class="comment"> *    https://www.khronos.org/registry/</span>
<a name="l00019"></a>00019 <span class="comment"> *</span>
<a name="l00020"></a>00020 <span class="comment"> * THE MATERIALS ARE PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND,</span>
<a name="l00021"></a>00021 <span class="comment"> * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF</span>
<a name="l00022"></a>00022 <span class="comment"> * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.</span>
<a name="l00023"></a>00023 <span class="comment"> * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY</span>
<a name="l00024"></a>00024 <span class="comment"> * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,</span>
<a name="l00025"></a>00025 <span class="comment"> * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE</span>
<a name="l00026"></a>00026 <span class="comment"> * MATERIALS OR THE USE OR OTHER DEALINGS IN THE MATERIALS.</span>
<a name="l00027"></a>00027 <span class="comment"> */</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#ifndef VX_INTERNAL_H_</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor">#define VX_INTERNAL_H_</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &lt;stdarg.h&gt;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;stdlib.h&gt;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="preprocessor">#include &lt;VX/vx.h&gt;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &lt;<a class="code" href="tivx_8h.html" title="Interface to TI extension APIs.">TI/tivx.h</a>&gt;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &lt;<a class="code" href="tivx__mem_8h.html" title="Interface to Memory allocation and deallocation APIs.">TI/tivx_mem.h</a>&gt;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &lt;<a class="code" href="tivx__obj__desc_8h.html" title="Interface to object descriptor.">TI/tivx_obj_desc.h</a>&gt;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &lt;<a class="code" href="tivx__target__kernel_8h.html" title="Interface to kernel APIs on target.">TI/tivx_target_kernel.h</a>&gt;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &lt;<a class="code" href="tivx__debug_8h.html" title="The Internal Debugging API.">TI/tivx_debug.h</a>&gt;</span>
<a name="l00044"></a>00044 <span class="preprocessor">#include &lt;<a class="code" href="tivx__platform_8h.html" title="Platform APIs.">tivx_platform.h</a>&gt;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &lt;<a class="code" href="tivx__ipc_8h.html" title="Inter-processor Communication (IPC) APIs.">tivx_ipc.h</a>&gt;</span>
<a name="l00046"></a>00046 <span class="preprocessor">#include &lt;<a class="code" href="tivx__mutex_8h.html" title="Interface to Mutex APIs.">TI/tivx_mutex.h</a>&gt;</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include &lt;<a class="code" href="tivx__event_8h.html" title="Interface to Event APIs.">TI/tivx_event.h</a>&gt;</span>
<a name="l00048"></a>00048 <span class="preprocessor">#include &lt;<a class="code" href="tivx__task_8h.html" title="Interface to Task APIs.">TI/tivx_task.h</a>&gt;</span>
<a name="l00049"></a>00049 <span class="preprocessor">#include &lt;<a class="code" href="tivx__queue_8h.html" title="Interface to Queue APIs.">TI/tivx_queue.h</a>&gt;</span>
<a name="l00050"></a>00050 <span class="preprocessor">#include &lt;<a class="code" href="tivx__obj__desc__priv_8h.html" title="Internal private implementation of object descriptor.">tivx_obj_desc_priv.h</a>&gt;</span>
<a name="l00051"></a>00051 <span class="preprocessor">#include &lt;<a class="code" href="tivx__target_8h.html" title="Implementation of Target Object APIs.">tivx_target.h</a>&gt;</span>
<a name="l00052"></a>00052 <span class="preprocessor">#include &lt;<a class="code" href="tivx__target__kernel__priv_8h.html" title="Target Kernel implementation APIs.">tivx_target_kernel_priv.h</a>&gt;</span>
<a name="l00053"></a>00053 <span class="preprocessor">#include &lt;<a class="code" href="tivx__target__kernel__instance_8h.html" title="Target Kernel Instance implementation APIs.">tivx_target_kernel_instance.h</a>&gt;</span>
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 <span class="preprocessor">#include &lt;<a class="code" href="vx__reference_8h.html" title="Implementation of Reference object.">vx_reference.h</a>&gt;</span>
<a name="l00056"></a>00056 <span class="preprocessor">#include &lt;<a class="code" href="vx__context_8h.html" title="Implementation of Context object.">vx_context.h</a>&gt;</span>
<a name="l00057"></a>00057 <span class="preprocessor">#include &lt;<a class="code" href="vx__error_8h.html" title="The internal error implementation.">vx_error.h</a>&gt;</span>
<a name="l00058"></a>00058 <span class="preprocessor">#include &lt;<a class="code" href="vx__graph_8h.html" title="Implementation of Graph object.">vx_graph.h</a>&gt;</span>
<a name="l00059"></a>00059 <span class="preprocessor">#include &lt;<a class="code" href="vx__kernel_8h.html" title="Implementation of Kernel object.">vx_kernel.h</a>&gt;</span>
<a name="l00060"></a>00060 <span class="preprocessor">#include &lt;<a class="code" href="vx__node_8h.html" title="Implementation of Node object.">vx_node.h</a>&gt;</span>
<a name="l00061"></a>00061 <span class="preprocessor">#include &lt;<a class="code" href="vx__parameter_8h.html" title="Implementation of Parameter object.">vx_parameter.h</a>&gt;</span>
<a name="l00062"></a>00062 <span class="preprocessor">#include &lt;<a class="code" href="vx__remap_8h.html" title="Implementation of Remap object.">vx_remap.h</a>&gt;</span>
<a name="l00063"></a>00063 <span class="preprocessor">#include &lt;<a class="code" href="vx__scalar_8h.html" title="Implementation of Scalar object.">vx_scalar.h</a>&gt;</span>
<a name="l00064"></a>00064 <span class="preprocessor">#include &lt;<a class="code" href="vx__image_8h.html" title="Implementation of Image object.">vx_image.h</a>&gt;</span>
<a name="l00065"></a>00065 <span class="preprocessor">#include &lt;<a class="code" href="vx__matrix_8h.html" title="Implementation of Matrix object.">vx_matrix.h</a>&gt;</span>
<a name="l00066"></a>00066 <span class="preprocessor">#include &lt;<a class="code" href="vx__lut_8h.html" title="Implementation of Lut object.">vx_lut.h</a>&gt;</span>
<a name="l00067"></a>00067 <span class="preprocessor">#include &lt;<a class="code" href="vx__convolution_8h.html" title="Implementation of Lut object.">vx_convolution.h</a>&gt;</span>
<a name="l00068"></a>00068 <span class="preprocessor">#include &lt;<a class="code" href="vx__distribution_8h.html" title="Implementation of Lut object.">vx_distribution.h</a>&gt;</span>
<a name="l00069"></a>00069 <span class="preprocessor">#include &lt;<a class="code" href="vx__threshold_8h.html" title="Implementation of Threshold object.">vx_threshold.h</a>&gt;</span>
<a name="l00070"></a>00070 <span class="preprocessor">#include &lt;<a class="code" href="vx__pyramid_8h.html" title="Implementation of Pyramid object.">vx_pyramid.h</a>&gt;</span>
<a name="l00071"></a>00071 <span class="preprocessor">#include &lt;<a class="code" href="vx__objarray_8h.html" title="Implementation of Object Array data object.">vx_objarray.h</a>&gt;</span>
<a name="l00072"></a>00072 <span class="preprocessor">#include &lt;<a class="code" href="vx__array_8h.html" title="Implementation of Array object.">vx_array.h</a>&gt;</span>
<a name="l00073"></a>00073 <span class="preprocessor">#include &lt;<a class="code" href="vx__delay_8h.html" title="Implementation of Delay object.">vx_delay.h</a>&gt;</span>
<a name="l00074"></a>00074 <span class="preprocessor">#include &lt;<a class="code" href="vx__module_8h.html" title="Implementation of Module APIs.">vx_module.h</a>&gt;</span>
<a name="l00075"></a>00075 <span class="preprocessor">#include &lt;<a class="code" href="vx__meta__format_8h.html" title="Implementation of Meta Format Object.">vx_meta_format.h</a>&gt;</span>
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 <span class="preprocessor">#include &lt;<a class="code" href="tivx__objects_8h.html" title="Internal header file defining max number of supported for each object.">tivx_objects.h</a>&gt;</span>
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 <span class="preprocessor">#ifdef __cplusplus</span>
<a name="l00081"></a>00081 <span class="preprocessor"></span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00082"></a>00082 <span class="preprocessor">#endif</span>
<a name="l00083"></a>00083 <span class="preprocessor"></span>
<a name="l00092"></a><a class="code" href="group__group__vx__utils.html#ga3ce34986ae4e8bb261f86e769fbbc167">00092</a> <span class="preprocessor">#define TIVX_ALIGN(value, align)      ((((value)+((align)-1))/(align))*(align))</span>
<a name="l00093"></a>00093 <span class="preprocessor"></span>
<a name="l00097"></a><a class="code" href="group__group__vx__utils.html#gaa68f32003477b404904062d7786fc3bd">00097</a> <span class="preprocessor">#define TIVX_FLOOR(value, align)      (((value)/(align))*(align))</span>
<a name="l00098"></a>00098 <span class="preprocessor"></span>
<a name="l00102"></a><a class="code" href="group__group__vx__utils.html#gafed0fc37f24bfac4e4593ee9d3b87c8e">00102</a> <span class="preprocessor">#define TIVX_DEFAULT_STRIDE_Y_ALIGN   (16U)</span>
<a name="l00103"></a>00103 <span class="preprocessor"></span>
<a name="l00107"></a><a class="code" href="group__group__vx__utils.html#gab4ba474b742b4fe12aed4cd4691bb6b9">00107</a> <span class="preprocessor">#define TIVX_TYPE_IS_SCALAR(type) ((VX_TYPE_INVALID &lt; (type)) &amp;&amp; ((type) &lt; VX_TYPE_SCALAR_MAX))</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>
<a name="l00112"></a><a class="code" href="group__group__vx__utils.html#ga8046b2f6f99302f66e9e8153a230baf6">00112</a> <span class="preprocessor">#define TIVX_TYPE_IS_STRUCT(type) (((type) &gt;= VX_TYPE_RECTANGLE) &amp;&amp; ((type) &lt; VX_TYPE_KHRONOS_STRUCT_MAX))</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span>
<a name="l00117"></a><a class="code" href="group__group__vx__utils.html#ga93a451188d2830ed50d094120433500d">00117</a> <span class="preprocessor">#define TIVX_TYPE_IS_OBJECT(type) (((type) &gt;= VX_TYPE_REFERENCE) &amp;&amp; ((type) &lt; VX_TYPE_KHRONOS_OBJECT_END))</span>
<a name="l00118"></a>00118 <span class="preprocessor"></span>
<a name="l00122"></a><a class="code" href="group__group__vx__utils.html#ga41ea76fbd9c3d52fa0dd25e3b0152b3e">00122</a> <span class="preprocessor">#define TIVX_MAGIC            (0xFACEC0DEU)</span>
<a name="l00123"></a>00123 <span class="preprocessor"></span>
<a name="l00124"></a>00124 
<a name="l00128"></a><a class="code" href="group__group__vx__utils.html#ga03c1805a3a7258cf0ec83ad8daab1838">00128</a> <span class="preprocessor">#define TIVX_BAD_MAGIC        (42)</span>
<a name="l00129"></a>00129 <span class="preprocessor"></span>
<a name="l00133"></a><a class="code" href="group__group__vx__utils.html#ga7986a750054beb62c0f9f720843e9495">00133</a> <span class="preprocessor">#define VX_CHECK_PARAM(ptr, size, type, align) ((size == sizeof(type)) &amp;&amp; (((vx_size)ptr &amp; align) == 0))</span>
<a name="l00134"></a>00134 <span class="preprocessor"></span>
<a name="l00138"></a>00138 <span class="preprocessor">#ifndef dimof</span>
<a name="l00139"></a><a class="code" href="group__group__vx__utils.html#ga077bde7b4af50f959972477bba9569ef">00139</a> <span class="preprocessor"></span><span class="preprocessor">#define dimof(x) (sizeof(x)/sizeof(x[0]))</span>
<a name="l00140"></a>00140 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00141"></a>00141 <span class="preprocessor"></span>
<a name="l00142"></a>00142 <span class="keyword">static</span> <span class="keyword">inline</span> <a class="code" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0" title="A Boolean value. This allows 0 to be FALSE, as it is in C, and any non-zero to be...">vx_bool</a> <a class="code" href="group__group__vx__utils.html#ga8e19e8244e8e40dac1af54ce04ac0b3a" title="Macro to check if flag is set, flag MUST be of bit type.">tivxFlagIsBitSet</a>(uint32_t flag_var, uint32_t flag_val);
<a name="l00143"></a>00143 <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="group__group__vx__utils.html#gabe1484e1cc6d183d574ff47720dba6f6" title="Macro to set flag value, flag MUST be of bit type.">tivxFlagBitSet</a>(uint32_t *flag_var, uint32_t flag_val);
<a name="l00144"></a>00144 <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="group__group__vx__utils.html#ga534109d6c33d7c81285c09c9e1bd9892" title="Macro to clear flag value, flag MUST be of bit type.">tivxFlagBitClear</a>(uint32_t *flag_var, uint32_t flag_val);
<a name="l00145"></a>00145 <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="group__group__vx__utils.html#ga9bed7333f57423a1af3cc2c624016efa" title="Macro to convert 2x uint32 to uint64.">tivx_uint32_to_uint64</a>(uint64_t *val, uint32_t h, uint32_t l);
<a name="l00146"></a>00146 <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="group__group__vx__utils.html#ga278ed34a28b05b22e15ee4a29b9a0935" title="Macro to convert uint64 to 2x uint32.">tivx_uint64_to_uint32</a>(uint64_t val, uint32_t *h, uint32_t *l);
<a name="l00147"></a>00147 
<a name="l00151"></a><a class="code" href="group__group__vx__utils.html#ga8e19e8244e8e40dac1af54ce04ac0b3a">00151</a> <span class="keyword">static</span> <span class="keyword">inline</span> <a class="code" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0" title="A Boolean value. This allows 0 to be FALSE, as it is in C, and any non-zero to be...">vx_bool</a> <a class="code" href="group__group__vx__utils.html#ga8e19e8244e8e40dac1af54ce04ac0b3a" title="Macro to check if flag is set, flag MUST be of bit type.">tivxFlagIsBitSet</a>(uint32_t flag_var, uint32_t flag_val)
<a name="l00152"></a>00152 {
<a name="l00153"></a>00153     <span class="keywordflow">return</span> (<a class="code" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0" title="A Boolean value. This allows 0 to be FALSE, as it is in C, and any non-zero to be...">vx_bool</a>)((flag_var &amp; flag_val) == flag_val);
<a name="l00154"></a>00154 }
<a name="l00155"></a>00155 
<a name="l00159"></a><a class="code" href="group__group__vx__utils.html#gabe1484e1cc6d183d574ff47720dba6f6">00159</a> <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="group__group__vx__utils.html#gabe1484e1cc6d183d574ff47720dba6f6" title="Macro to set flag value, flag MUST be of bit type.">tivxFlagBitSet</a>(uint32_t *flag_var, uint32_t flag_val)
<a name="l00160"></a>00160 {
<a name="l00161"></a>00161     *flag_var |= flag_val;
<a name="l00162"></a>00162 }
<a name="l00163"></a>00163 
<a name="l00167"></a><a class="code" href="group__group__vx__utils.html#ga534109d6c33d7c81285c09c9e1bd9892">00167</a> <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="group__group__vx__utils.html#ga534109d6c33d7c81285c09c9e1bd9892" title="Macro to clear flag value, flag MUST be of bit type.">tivxFlagBitClear</a>(uint32_t *flag_var, uint32_t flag_val)
<a name="l00168"></a>00168 {
<a name="l00169"></a>00169     uint32_t value = *flag_var;
<a name="l00170"></a>00170 
<a name="l00171"></a>00171     value = value &amp; ~flag_val;
<a name="l00172"></a>00172 
<a name="l00173"></a>00173     *flag_var = value;
<a name="l00174"></a>00174 }
<a name="l00175"></a>00175 
<a name="l00179"></a><a class="code" href="group__group__vx__utils.html#ga9bed7333f57423a1af3cc2c624016efa">00179</a> <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="group__group__vx__utils.html#ga9bed7333f57423a1af3cc2c624016efa" title="Macro to convert 2x uint32 to uint64.">tivx_uint32_to_uint64</a>(uint64_t *val, uint32_t h, uint32_t l)
<a name="l00180"></a>00180 {
<a name="l00181"></a>00181     *val = ((uint64_t)h&lt;&lt;32) | (uint64_t)l;
<a name="l00182"></a>00182 }
<a name="l00183"></a>00183 
<a name="l00187"></a><a class="code" href="group__group__vx__utils.html#ga278ed34a28b05b22e15ee4a29b9a0935">00187</a> <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="group__group__vx__utils.html#ga278ed34a28b05b22e15ee4a29b9a0935" title="Macro to convert uint64 to 2x uint32.">tivx_uint64_to_uint32</a>(uint64_t val, uint32_t *h, uint32_t *l)
<a name="l00188"></a>00188 {
<a name="l00189"></a>00189     *h = (uint32_t)(val &gt;&gt; 32);
<a name="l00190"></a>00190     *l = (uint32_t)(val &gt;&gt;  0);
<a name="l00191"></a>00191 }
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 <span class="preprocessor">#ifdef __cplusplus</span>
<a name="l00195"></a>00195 <span class="preprocessor"></span>}
<a name="l00196"></a>00196 <span class="preprocessor">#endif</span>
<a name="l00197"></a>00197 <span class="preprocessor"></span>
<a name="l00198"></a>00198 <span class="preprocessor">#endif</span>
<a name="l00199"></a>00199 <span class="preprocessor"></span>
</pre></div></div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
